unit Message;

interface
uses
  screen,box,publvar;

const
  _MessageMax      =20;
  _SpecialChar:char='^';

type
      _String80=string[80];

      _MessageType=record
        Strings:_String80;
        SCC:byte { Special Char Color }
      end;

      PMessage=object(PShadow)
        CM,         { Count Message }
        MC,         { Message Color }
        MX,MY:byte; { Message X, Y }
        Message :array[1.._MessageMax] of ^_MessageType;

        constructor Init;
        destructor  Done;
        procedure Add(S:string);
        procedure Clear;
        procedure SetColor(C:byte;NF:boolean);
        procedure SetXY(X,Y:byte);
        procedure SpecialCharColor(SC:byte;NF:boolean);
        procedure Draw; virtual;
      end;

implementation

procedure Print(X,Y,MC:byte;S:_MessageType);
var Special:boolean;
    CPosition, XPosition:byte;
begin
  Special  :=off;
  CPosition:=0;
  XPosition:=X;

  while CPosition < length(S.Strings) do begin
    inc(CPosition);

    if S.Strings[CPosition]=_SpecialChar then Special:=not Special
    else begin
      inc(XPosition);
      if Special then FWrite(S.Strings[CPosition],XPosition,Y,S.SCC)
      else            FWrite(S.Strings[CPosition],XPosition,Y,MC)
    end
  end
end;

function MsgLength(S:string):byte;
var T,Count:byte;
begin
  Count:=0;
  for T:=1 to length(S) do
    if S[T]=_SpecialChar then inc(Count);

  MsgLength:=length(S)-Count
end;

procedure PMessage.SpecialCharColor;
begin
  if NF then Message[CM]^.SCC:=SC+16*(LineBackColor div 16)
  else       Message[CM]^.SCC:=SC
end;

procedure PMessage.SetColor;
begin
  if NF then MC:=C+16*(LineBackColor div 16)
  else       MC:=C
end;

constructor PMessage.Init;
var T:byte;
begin
  PBox.Init;

  SetColor(15,On);
  CM:=0;
  MX:=1;
  MY:=1;

  for T:=1 to _MessageMax do begin
    new(Message[T]);
    Message[T]^.Strings:='';
    Message[T]^.SCC:=Color(14,LineBackColor)
  end
end;

procedure PMessage.Clear;
var T:byte;
begin
  CM:=0;
  for T:=1 to _MessageMax do begin
    Message[T]^.Strings:='';
    Message[T]^.SCC:=Color(14,LineBackColor)
  end
end;

procedure PMessage.SetXY;
begin
  MX:=X;
  MY:=Y
end;

destructor PMessage.Done;
var T:byte;
begin
  for T:=1 to _MessageMax do dispose(Message[T])
end;

procedure PMessage.Add;
begin
  if CM < _MessageMax then inc(CM);
  Message[CM]^.Strings:=S
end;

procedure PMessage.Draw;
var LengthMax,T,Len:byte;
begin
  { find max length }
  LengthMax:=0;
  for T:=1 to CM do begin
    Len:=MsgLength(Message[T]^.Strings);
    if Len > LengthMax then LengthMax:=Len
  end;

  { find Box coordinates }
  Top   :=MY;
  Left  :=MX;
  Bottom:=MY+succ(CM);
  Right :=MX+succ(LengthMax);

  { draw message background }
  BCnt(Top,Left,Bottom,Right);
  PShadow.Draw;

  { draw message }
  for T:=1 to CM do Print(Left,Top+T,MC,Message[T]^)
end;

end.
